package bank2;

import java.util.*;

/*
 * The Bank class is a demo for a multi-threaded system which manages aaaaa accounts
 * while keeping track of their internal balance. The chance for error is very low
 * although possible for the lack of synchronization.
 */
public class Bank {

	// Total balance as recorded in bank.
	static int Bank_Total;

	
	// all accounts
	static Account[] accounts;
	// all accounts
	static Thread[] threads;

	// random numbers generator
	//static int  Bank_random = 2;;
	static Random Bank_random = new Random();

	static Object lock = new Integer(0);
	static Object lock1 = new Integer(1);

	// The number of accounts is randomly chosen from [10,110]
	 //static int NUM_ACCOUNTS = Math.abs((Bank_random.nextInt()%10 + 1)*10);
	static final int NUM_ACCOUNTS = 2; // number of threads + 1 for Bank
	
	
	// for performance testing
	static long currentTime = System.currentTimeMillis();

	/*
	 * Method main creates all the accounts from which the Bank accepts requests
	 * for actions. The total sum of the accounts is recorded on each action
	 * execution.
	 */
	public static void main(String args[]) {

		// state = new State();
		accounts = new Account[NUM_ACCOUNTS];
		threads = new Thread[NUM_ACCOUNTS];

			// reset example
			Bank_Total = 0;
			
			// create all accounts
			for (int i = 0; i < NUM_ACCOUNTS; i++) {
				if (i  <( NUM_ACCOUNTS/2))
					accounts[i] = new Account(i,true);
				else
					accounts[i] = new Account(i,false);
					
			}

			System.out.print("Bank week started..");

			// start all accounts
			for (int i = 0; i < NUM_ACCOUNTS; i++) {
				System.out.println("i: "+ i + " " + accounts[i].toString());
				threads[i] = new Thread(accounts[i]);
				System.out.println(threads[i].getName());
				threads[i].start();
			}

			/* wait for all threads (accounts) to die. */
			for (int i = 0; i < NUM_ACCOUNTS; i++) {
				try {
					threads[i].join();
				} catch (Exception e) {
					System.out.printf("grrrr\n");
				}
			}

			System.out.println("");
			System.out.println("End of the week.");

			int Total_Balance = 0;
			// sum up all balances.
			for (int i = 0; i < NUM_ACCOUNTS; i++) {
				//System.out.println( i +" suma:"+  accounts[i].Balance);
				Total_Balance += accounts[i].Balance;
			}
			// Give report.
			System.out.println("Bank records = " + Bank_Total + ", accounts balance = " + Total_Balance + ".");
			currentTime=System.currentTimeMillis() - currentTime;
			if (Bank_Total == Total_Balance)
				System.out.println("OK records match TIME=" + currentTime);
			else
				System.out.println("ERROR: records don't match !!! TIME=" + currentTime);

	}

	/*
	 * The Service method performs the actual action on the account, and it also
	 * updates the Bank's records. (Bank_Total)
	 */
	/* pridat synchronized.... */
	public static void Service(int id, int sum) {
		accounts[id].Balance += sum;
		Bank_Total += sum;
	}

	public static void ServiceOK(int id, int sum) {
		synchronized (lock) {
			Bank_Total += sum;
			accounts[id].Balance += sum;
		}
	}
	
}
